#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <fun>
#include <hamsandwich>
#include <xs>
#include <cstrike>
#include <zombieplague>
#include <fakemeta_util>

#define weapon_balrog7_kobra "weapon_m249"
#define CSW_BALROG7 CSW_M249

#define ENG_NULLENT		-1
#define EV_INT_WEAPONKEY	EV_INT_impulse
#define balrog-7_WEAPONKEY	904
#define MAX_PLAYERS  			  32
#define IsValidUser(%1) (1 <= %1 <= g_MaxPlayers)
#define write_coord_f(%1)	engfunc(EngFunc_WriteCoord, %1)

const USE_STOPPED = 0
const OFFSET_ACTIVE_ITEM = 373
const OFFSET_WEAPONOWNER = 41
const OFFSET_LINUX = 5
const OFFSET_LINUX_WEAPONS = 4

#define WEAP_LINUX_XTRA_OFF			4
#define m_fKnown				44
#define m_flNextPrimaryAttack 			46
#define m_flTimeWeaponIdle			48
#define m_iClip					51
#define m_fInReload				54
#define PLAYER_LINUX_XTRA_OFF			5
#define m_flNextAttack				83

#define RELOAD_TIME		4.0
#define BODY_SKIN_W_BALROG7		23
#define BALROG7_COST		0

const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)

new const Fire_snd[] = { "weapons/balrog7-1.wav" }

new const GUNSHOT_DECALS[] = { 41, 42, 43, 44, 45 }

new balrog7_V_MODEL[64] = "models/zp/v_balrog7.mdl"
new balrog7_P_MODEL[64] = "models/zp/p_balrog7.mdl"
new balrog7_W_MODEL[64] = "models/zp/w_balrog7.mdl"
new balrog7_SHELL_MODEL[64] = "models/rshell.mdl"

new cvar_dmg_balrog7, g_itemid_balrog7, cvar_clip_balrog7, cvar_balrog7_ammo, cvar_shellshealth_balrog7, shells_model
new g_has_balrog7[33]
new g_MaxPlayers, g_orig_event_balrog7, g_clip_ammo[33]
new Float:cl_pushangle[MAX_PLAYERS + 1][3], m_iBlood[2], weapon_vars[10]
new g_balrog7_TmpClip[33]
new Float:g_lastexpl[33], sExplo, in_zoom[33]

public plugin_init()
{
	register_plugin("Balrog-7", "1.0", "Crock / =)")
	register_event("CurWeapon", "CurrentWeapon", "be", "1=1")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_m249", "fw_balrog7_AddToPlayer")
	RegisterHam(Ham_Use, "func_tank", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Item_Deploy, "weapon_m249", "fw_Item_Deploy_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_m249", "fw_balrog7_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_m249", "fw_balrog7_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Item_PostFrame, "weapon_m249", "balrog7__ItemPostFrame");
	RegisterHam(Ham_Weapon_Reload, "weapon_m249", "balrog7__Reload");
	RegisterHam(Ham_Weapon_Reload, "weapon_m249", "balrog7__Reload_Post", 1);
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_SetModel, "fw_SetModel")
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)
	register_forward(FM_PlaybackEvent, "fwPlaybackEvent")
	
	cvar_dmg_balrog7 = register_cvar("zp_balrog-7_dmg", "1.15")
	cvar_clip_balrog7 = register_cvar("zp_balrog-7_clip", "120")
	cvar_balrog7_ammo = register_cvar("zp_balrog-7_ammo", "240")
	cvar_shellshealth_balrog7 = register_cvar("zp_balrog7_shellslife", "2")
	
	register_clcmd("weapon_balrog7", "client_cmd_balrog7")
	
	g_itemid_balrog7 = zp_register_extra_item("Balrog-7", BALROG7_COST, ZP_TEAM_HUMAN)
	
	g_MaxPlayers = get_maxplayers()
}

public plugin_precache()
{
	precache_model(balrog7_V_MODEL)
	precache_model(balrog7_P_MODEL)
	precache_model(balrog7_W_MODEL)
	shells_model = precache_model(balrog7_SHELL_MODEL)
	precache_sound(Fire_snd)
	precache_sound("weapons/balrog7-2.wav")
	precache_sound("weapons/balrog7_clipin1.wav")
	precache_sound("weapons/balrog7_clipin2.wav")
	precache_sound("weapons/balrog7_clipin3.wav")
	precache_sound("weapons/balrog7_clipout1.wav")
	precache_sound("weapons/balrog7_clipout2.wav")
	sExplo = precache_model("sprites/zerogxplode.spr")
	m_iBlood[0] = precache_model("sprites/blood.spr")
	m_iBlood[1] = precache_model("sprites/bloodspray.spr")
	precache_generic("sprites/weapon_balrog7.txt")
   	precache_generic("sprites/640hud76.spr")
    	precache_generic("sprites/640hud2.spr")
	
	register_forward(FM_PrecacheEvent, "fwPrecacheEvent_Post", 1)
	register_message(78, "msg_weaplist")
}

public client_cmd_balrog7(id)
{
	engclient_cmd(id, "weapon_m249")
}

public zp_user_humanized_post(id)
{
	g_has_balrog7[id] = false
}

public plugin_natives ()
{
	register_native("give_weapon_balrog7", "native_give_weapon_add", 1)
	register_native("drop_weapon_balrog7", "native_drop_weapon", 1)
}

public native_give_weapon_add(id)
{
	give_balrog7(id)
}

public native_drop_weapon(id)
{
	ham_strip_weapon(id, "weapon_m249")
}

public fwPrecacheEvent_Post(type, const name[])
{
	if(equal("events/m249.sc", name))
	{
		g_orig_event_balrog7 = get_orig_retval()
		return FMRES_HANDLED
	}
	return FMRES_IGNORED
}

public client_connect(id)
{
	g_has_balrog7[id] = false
}

public client_disconnect(id)
{
	g_has_balrog7[id] = false
}

public zp_user_infected_post(id)
{
	if(zp_get_user_zombie(id))
	{
		g_has_balrog7[id] = false
	}
}

public fw_SetModel(entity, model[])
{
	if(!is_valid_ent(entity))
		return FMRES_IGNORED;
	static szClassName[33]
	entity_get_string(entity, EV_SZ_classname, szClassName, charsmax(szClassName))
	if(!equal(szClassName, "weaponbox"))
		return FMRES_IGNORED;
	static iOwner
	iOwner = entity_get_edict(entity, EV_ENT_owner)
	if(equal(model, "models/w_m249.mdl"))
	{
		static iStoredSVDID
		iStoredSVDID = find_ent_by_owner(ENG_NULLENT, "weapon_m249", entity)
		if(!is_valid_ent(iStoredSVDID))
			return FMRES_IGNORED;
		if(g_has_balrog7[iOwner])
		{
			entity_set_int(iStoredSVDID, EV_INT_WEAPONKEY, balrog-7_WEAPONKEY)
			g_has_balrog7[iOwner] = false
			set_weaplist(iOwner, 0)
			entity_set_model(entity, balrog7_W_MODEL)
			set_pev(entity, pev_body, BODY_SKIN_W_BALROG7)
			
			return FMRES_SUPERCEDE;
		}
	}
	return FMRES_IGNORED;
}

public give_balrog7(id)
{
	drop_weapons(id, 1);
	new iWep2 = give_item(id, "weapon_m249")
	if(iWep2 > 0)
	{
		cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_balrog7))
		cs_set_user_bpammo(id, CSW_BALROG7, get_pcvar_num(cvar_balrog7_ammo))
		message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("AmmoPickup"), _, id)
		write_byte(3)
		write_byte(240)
		message_end()
		set_weaplist(id, 1)
	}
	g_has_balrog7[id] = true;
}

public zp_extra_item_selected(id, itemid)
{
	if(itemid != g_itemid_balrog7)
		return
	
	give_balrog7(id)
}

public fw_balrog7_AddToPlayer(balrog7, id)
{
	if(!is_valid_ent(balrog7) || !is_user_connected(id))
		return HAM_IGNORED;
	
	if(entity_get_int(balrog7, EV_INT_WEAPONKEY) == balrog-7_WEAPONKEY)
	{
		g_has_balrog7[id] = true
		set_weaplist(id, 1)
		entity_set_int(balrog7, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED;
	}
	return HAM_IGNORED;
}

public fw_UseStationary_Post(entity, caller, activator, use_type)
{
	if(use_type == USE_STOPPED && is_user_connected(caller))
		replace_weapon_models(caller, get_user_weapon(caller))
}

public fw_Item_Deploy_Post(weapon_ent)
{
	static owner
	owner = fm_cs_get_weapon_ent_owner(weapon_ent)
	
	static weaponid
	weaponid = cs_get_weapon_id(weapon_ent)
	
	replace_weapon_models(owner, weaponid)
}

public CurrentWeapon(id)
{
	replace_weapon_models(id, read_data(2))
}

replace_weapon_models(id, weaponid)
{
switch (weaponid)
{
	case CSW_BALROG7:
	{
		if(zp_get_user_zombie(id))
			return;
			
		if(g_has_balrog7[id])
			{
				set_pev(id, pev_viewmodel2, balrog7_V_MODEL)
				set_pev(id, pev_weaponmodel2, balrog7_P_MODEL)
			}
		}
	}
}

public fw_UpdateClientData_Post(Player, SendWeapons, CD_Handle)
{
	if(!is_user_alive(Player) || (get_user_weapon(Player) != CSW_BALROG7) || !g_has_balrog7[Player])
		return FMRES_IGNORED
	
	set_cd(CD_Handle, CD_flNextAttack, halflife_time () + 0.001)
	return FMRES_HANDLED
}

public fw_balrog7_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	if(!g_has_balrog7[Player])
		return;
	
	pev(Player, pev_punchangle, cl_pushangle[Player])
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fwPlaybackEvent(flags, invoker, eventid, Float:delay, Float:origin[3], Float:angles[3], Float:fparam1, Float:fparam2, iParam1, iParam2, bParam1, bParam2)
{
	if((eventid != g_orig_event_balrog7))
		return FMRES_IGNORED
	if(!(1 <= invoker <= g_MaxPlayers))
		return FMRES_IGNORED
	playback_event(flags | FEV_HOSTONLY, invoker, eventid, delay, origin, angles, fparam1, fparam2, iParam1, iParam2, bParam1, bParam2)
	return FMRES_SUPERCEDE
}

public fw_CmdStart(id, uc_handle, seed) 
{
	new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)
	if(g_has_balrog7[id] && get_user_weapon(id) == CSW_M249 && (get_uc(uc_handle, UC_Buttons) & IN_ATTACK2) && !(pev(id, pev_oldbuttons) & IN_ATTACK2) && flNextAttack < 0.1)
	{
		if(!in_zoom[id])
		{
			cs_set_user_zoom(id, CS_SET_AUGSG552_ZOOM, 0)
			emit_sound(id, CHAN_ITEM, "weapons/zoom.wav", 0.20, 2.40, 0, 100)
			in_zoom[id] = 1
		}
		else if(in_zoom[id])
		{
			in_zoom[id] = 0
			cs_set_user_zoom(id, CS_RESET_ZOOM, 1)
			emit_sound(id, CHAN_ITEM, "weapons/zoom.wav", 0.20, 2.40, 0, 100)
		}
	}
}

public fw_balrog7_PrimaryAttack_Post(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	if(Player > 0 && Player < 33)
	{
		if(g_has_balrog7[Player])
		{
			if(szClip > 0) emit_sound(Player, CHAN_WEAPON, Fire_snd, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		}
		if(g_has_balrog7[Player])
		{
			new Float:push[3]
			pev(Player, pev_punchangle, push)
			xs_vec_sub(push, cl_pushangle[Player], push)
			xs_vec_mul_scalar(push, 0.6, push)
			xs_vec_add(push, cl_pushangle[Player], push)
			set_pev(Player, pev_punchangle, push)
			
			if(!g_clip_ammo[Player])
				return
			
			UTIL_PlayWeaponAnimation(Player, random_num(1, 2))
			make_blood_and_bulletholes(Player)
			make_shell(Player)
			
			if(get_gametime()-1.0 > g_lastexpl[Player])
			{
				explode(Player)
				UTIL_PlayWeaponAnimation(Player, 2)
				g_lastexpl[Player] = get_gametime()
			}
			if(in_zoom[Player]) set_pdata_float(Player, m_flNextAttack, 0.2, 5)
		}
	}
}

public explode(id)
{
	if(is_user_alive(id))
	{
		message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id);
		write_short(1<<8);
		write_short(1<<8);
		write_short(1<<0);
		write_byte(255);
		write_byte(0);
		write_byte(0);
		write_byte(100);
		message_end();
		
		new Float:originF[3]
		fm_get_aim_origin(id, originF)
		message_begin(MSG_ALL, SVC_TEMPENTITY)
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0])
		engfunc(EngFunc_WriteCoord, originF[1])
		engfunc(EngFunc_WriteCoord, originF[2]+30.0)
		message_end()
		
		message_begin(MSG_ALL, SVC_TEMPENTITY)
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0]+30.0)
		engfunc(EngFunc_WriteCoord, originF[1])
		engfunc(EngFunc_WriteCoord, originF[2]+30.0)
		message_end()
		
		message_begin(MSG_ALL, SVC_TEMPENTITY) 
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0])
		engfunc(EngFunc_WriteCoord, originF[1]+30.0)
		engfunc(EngFunc_WriteCoord, originF[2]+30.0)
		message_end()
		
		message_begin(MSG_ALL, SVC_TEMPENTITY)
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0])
		engfunc(EngFunc_WriteCoord, originF[1]+40.0)
		engfunc(EngFunc_WriteCoord, originF[2]+40.0)
		message_end()
		
		message_begin(MSG_ALL, SVC_TEMPENTITY)
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0])
		engfunc(EngFunc_WriteCoord, originF[1]+40.0)
		engfunc(EngFunc_WriteCoord, originF[2]+30.0)
		message_end()
		
		message_begin(MSG_ALL, SVC_TEMPENTITY)
		write_byte(TE_SPARKS)
		engfunc(EngFunc_WriteCoord, originF[0])
		engfunc(EngFunc_WriteCoord, originF[1]+30.0)
		engfunc(EngFunc_WriteCoord, originF[2]+40.0)
		message_end()
		
		// Draw explosion
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_EXPLOSION) // Temporary entity ID
		engfunc(EngFunc_WriteCoord, originF[0]) // engfunc because float
		engfunc(EngFunc_WriteCoord, originF[1])
		engfunc(EngFunc_WriteCoord, originF[2]+30.0)
		write_short(sExplo) // Sprite index
		write_byte(20) // Scale
		write_byte(30) // Framerate
		write_byte(0) // Flags
		message_end()
		
		// Alive...
		new a = FM_NULLENT
		// Get distance between victim and epicenter
		while((a = find_ent_in_sphere(a, originF, 60.0)) != 0)
		{
			if (id == a)
				continue 
				
			if(pev(a, pev_takedamage) != DAMAGE_NO)
			{
				ExecuteHamB(Ham_TakeDamage, a, id, id, 100.0, DMG_BULLET)
			}
		}
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage)
{
	if(victim != attacker && is_user_connected(attacker))
	{
		if(get_user_weapon(attacker) == CSW_BALROG7)
		{
			if(g_has_balrog7[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_balrog7))
		}
	}
}

stock fm_cs_get_current_weapon_ent(id)
{
	return get_pdata_cbase(id, OFFSET_ACTIVE_ITEM, OFFSET_LINUX);
}

stock fm_cs_get_weapon_ent_owner(ent)
{
	return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS);
}

stock UTIL_PlayWeaponAnimation(const Player, const Sequence)
{
	set_pev(Player, pev_weaponanim, Sequence)
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = Player)
	write_byte(Sequence)
	write_byte(pev(Player, pev_body))
	message_end()
}

stock make_blood_and_bulletholes(id)
{
	new aimOrigin[3], target, body
	get_user_origin(id, aimOrigin, 3)
	get_user_aiming(id, target, body)
	if(target > 0 && target <= g_MaxPlayers && zp_get_user_zombie(target))
	{
		new Float:fStart[3], Float:fEnd[3], Float:fRes[3], Float:fVel[3]
		pev(id, pev_origin, fStart)
		velocity_by_aim(id, 64, fVel)
		fStart[0] = float(aimOrigin[0])
		fStart[1] = float(aimOrigin[1])
		fStart[2] = float(aimOrigin[2])
		fEnd[0] = fStart[0]+fVel[0]
		fEnd[1] = fStart[1]+fVel[1]
		fEnd[2] = fStart[2]+fVel[2]
		new res
		engfunc(EngFunc_TraceLine, fStart, fEnd, 0, target, res)
		get_tr2(res, TR_vecEndPos, fRes)
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BLOODSPRITE)
		write_coord(floatround(fStart[0]))
		write_coord(floatround(fStart[1]))
		write_coord(floatround(fStart[2]))
		write_short(m_iBlood[1])
		write_short(m_iBlood[0])
		write_byte(70)
		write_byte(random_num(1, 2))
		message_end()
	}
	else if(!is_user_connected(target))
	{
		if(target)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_DECAL)
			write_coord(aimOrigin[0])
			write_coord(aimOrigin[1])
			write_coord(aimOrigin[2])
			write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
			write_short(target)
			message_end()
		}
		else
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_WORLDDECAL)
			write_coord(aimOrigin[0])
			write_coord(aimOrigin[1])
			write_coord(aimOrigin[2])
			write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
			message_end()
		}
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		write_coord(aimOrigin[0])
		write_coord(aimOrigin[1])
		write_coord(aimOrigin[2])
		write_short(id)
		write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
		message_end()
	}
}

public balrog7__ItemPostFrame(weapon_entity)
{
	new id = pev(weapon_entity, pev_owner)
	if(!is_user_connected(id))
		return HAM_IGNORED;
	
	if(!g_has_balrog7[id])
		return HAM_IGNORED;
	
	new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)
	new iBpAmmo = cs_get_user_bpammo(id, CSW_BALROG7);
	new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)
	new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF)
	if(!(get_user_button(id) & IN_ATTACK))
		g_lastexpl[id]=get_gametime()
	
	if(fInReload && flNextAttack <= 0.0)
	{
		new j = min(get_pcvar_num(cvar_clip_balrog7) - iClip, iBpAmmo)
		set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
		cs_set_user_bpammo(id, CSW_BALROG7, iBpAmmo-j);
		set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
		fInReload = 0
	}
	return HAM_IGNORED;
}

public balrog7__Reload(weapon_entity)
{
	new id = pev(weapon_entity, pev_owner)
	if(!is_user_connected(id))
		return HAM_IGNORED;
	
	if(!g_has_balrog7[id])
		return HAM_IGNORED;
	
	g_balrog7_TmpClip[id] = -1;
	new iBpAmmo = cs_get_user_bpammo(id, CSW_BALROG7);
	new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)
	if(iBpAmmo <= 0)
		return HAM_SUPERCEDE;
	
	if(iClip >= get_pcvar_num(cvar_clip_balrog7))
		return HAM_SUPERCEDE;
	
	g_balrog7_TmpClip[id] = iClip;
	return HAM_IGNORED;
}

public balrog7__Reload_Post(weapon_entity)
{
	new id = pev(weapon_entity, pev_owner)
	if(!is_user_connected(id))
		return HAM_IGNORED;
	
	if(!g_has_balrog7[id])
		return HAM_IGNORED;
	
	if(g_balrog7_TmpClip[id] == -1)
		return HAM_IGNORED;
	
	set_pdata_int(weapon_entity, m_iClip, g_balrog7_TmpClip[id], WEAP_LINUX_XTRA_OFF)
	
	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, RELOAD_TIME, WEAP_LINUX_XTRA_OFF)
	
	set_pdata_float(id, m_flNextAttack, RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)
	
	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)
	
	if(in_zoom[id])
	{
		in_zoom[id] = 0
		cs_set_user_zoom(id, CS_RESET_ZOOM, 1)
		emit_sound(id, CHAN_ITEM, "weapons/zoom.wav", 0.20, 2.40, 0, 100)
	}
	
	UTIL_PlayWeaponAnimation(id, 3)
	
	return HAM_IGNORED;
}

public msg_weaplist(msg_id, msg_dest, msg_entity)
{
	if(get_msg_arg_int(8) == CSW_BALROG7)
	{
		weapon_vars[2] = get_msg_arg_int(2)
		weapon_vars[3] = get_msg_arg_int(3)
		weapon_vars[4] = get_msg_arg_int(4)
		weapon_vars[5] = get_msg_arg_int(5)
		weapon_vars[6] = get_msg_arg_int(6)
		weapon_vars[7] = get_msg_arg_int(7)
		weapon_vars[8] = get_msg_arg_int(8)
		weapon_vars[9] = get_msg_arg_int(9)
	}
}

public set_weaplist(id, num)
{
	if(!is_user_connected(id))
		return;
	
	message_begin(MSG_ONE, get_user_msgid("WeaponList"), {0,0,0}, id) 
	write_string(num ? "weapon_balrog7": weapon_balrog7_kobra) 
	write_byte(weapon_vars[2]) 
	write_byte(weapon_vars[3]) 
	write_byte(weapon_vars[4]) 
	write_byte(weapon_vars[5]) 
	write_byte(weapon_vars[6]) 
	write_byte(weapon_vars[7]) 
	write_byte(weapon_vars[8]) 
	write_byte(weapon_vars[9]) 
	message_end()
}

stock drop_weapons(id, dropwhat)
{
	static weapons[32], num, i, weaponid
	num = 0
	get_user_weapons(id, weapons, num)
	
	for (i = 0; i < num; i++)
	{
		weaponid = weapons[i]
		
		if(dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM))
		{
			static wname[32]
			get_weaponname(weaponid, wname, sizeof wname - 1)
			engclient_cmd(id, "drop", wname)
		}
	}
}

public make_shell(id)
{
	if(!is_user_alive(id) || zp_get_user_zombie(id))
		return;
	
	if(get_user_weapon(id) != CSW_BALROG7) 
		return;
	
	if(!g_has_balrog7[id])
		return;
	
	static Float:player_origin[3], Float:origin[3], Float:origin2[3], Float:gunorigin[3], Float:oldangles[3], Float:v_forward[3], Float:v_forward2[3], Float:v_up[3], Float:v_up2[3], Float:v_right[3], Float:v_right2[3], Float:viewoffsets[3];
	pev(id,pev_v_angle, oldangles)
	pev(id,pev_origin,player_origin)
	pev(id, pev_view_ofs, viewoffsets);
	
	engfunc(EngFunc_MakeVectors, oldangles);
	
	global_get(glb_v_forward, v_forward);
	global_get(glb_v_up, v_up);
	global_get(glb_v_right, v_right);
	
	global_get(glb_v_forward, v_forward2);
	global_get(glb_v_up, v_up2);
	global_get(glb_v_right, v_right2);
	
	xs_vec_add(player_origin, viewoffsets, gunorigin);
	
	xs_vec_mul_scalar(v_forward, 10.3, v_forward);
	xs_vec_mul_scalar(v_right, 2.9, v_right);
	xs_vec_mul_scalar(v_up, -3.7, v_up);
	
	xs_vec_mul_scalar(v_forward2, 10.0, v_forward2);
	xs_vec_mul_scalar(v_right2, 3.0, v_right2);
	xs_vec_mul_scalar(v_up2, -4.0, v_up2);
	
	xs_vec_add(gunorigin, v_forward, origin);
	xs_vec_add(gunorigin, v_forward2, origin2);
	xs_vec_add(origin, v_right, origin);
	xs_vec_add(origin2, v_right2, origin2);
	xs_vec_add(origin, v_up, origin);
	xs_vec_add(origin2, v_up2, origin2);
	
	new Float:velocity[3]
	get_speed_vector(origin2, origin, random_float(140.0, 160.0), velocity)
	
	new angle = random_num(0, 360)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, id)
	write_byte(TE_MODEL)
	write_coord_f(origin[0])
	write_coord_f(origin[1])
	write_coord_f(origin[2])
	write_coord_f(velocity[0])
	write_coord_f(velocity[1])
	write_coord_f(velocity[2])
	write_angle(angle)
	write_short(shells_model)
	write_byte(1)
	write_byte(get_pcvar_num(cvar_shellshealth_balrog7) * 10)
	message_end()
	
	new Float:origin3[3]
	origin3 = origin
	
	xs_vec_mul_scalar(v_forward, 3.9, v_forward);
	xs_vec_add(origin, v_forward, origin);
	
	for(new i; i <= 32; i++)
	{
		if(!is_user_connected(i) || i == id) continue;
		
		if(!is_user_alive(i) && pev(i, pev_iuser2) == id && pev(i, pev_iuser1) == 4)
		{
			message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, i)
			write_byte(TE_MODEL)
			write_coord_f(origin3[0])
			write_coord_f(origin3[1])
			write_coord_f(origin3[2])
			write_coord_f(velocity[0])
			write_coord_f(velocity[1])
			write_coord_f(velocity[2])
			write_angle(angle)
			write_short(shells_model)
			write_byte(1)
			write_byte(get_pcvar_num(cvar_shellshealth_balrog7) * 10)
			message_end()	
		}
		else
		{
			message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, i)
			write_byte(TE_MODEL)
			write_coord_f(origin[0])
			write_coord_f(origin[1])
			write_coord_f(origin[2])
			write_coord_f(velocity[0])
			write_coord_f(velocity[1])
			write_coord_f(velocity[2])
			write_angle(angle)
			write_short(shells_model)
			write_byte(1)
			write_byte(get_pcvar_num(cvar_shellshealth_balrog7) * 10)
			message_end()	
		}
	}
}

stock get_speed_vector(const Float:origin1[3], const Float:origin2[3], Float:speed, Float:new_velocity[3])
{
	new_velocity[0] = origin2[0] - origin1[0]
	new_velocity[1] = origin2[1] - origin1[1]
	new_velocity[2] = origin2[2] - origin1[2]
	new Float:num = floatsqroot(speed * speed / (new_velocity[0] * new_velocity[0] + new_velocity[1] * new_velocity[1] + new_velocity[2] * new_velocity[2]))
	new_velocity[0] *= num
	new_velocity[1] *= num
	new_velocity[2] *= num
	
	return 1;
}

stock ham_strip_weapon(id, weapon[])
{
	if(!equal(weapon, "weapon_", 7)) return 0;
	
	new wId = get_weaponid(weapon);
	if(!wId) return 0;
	
	new wEnt;
	while((wEnt = engfunc(EngFunc_FindEntityByString, wEnt, "classname", weapon)) && pev(wEnt, pev_owner) != id) {}
	if(!wEnt) return 0;
	
	if(get_user_weapon(id) == wId) ExecuteHamB(Ham_Weapon_RetireWeapon, wEnt);
	
	if(!ExecuteHamB(Ham_RemovePlayerItem, id, wEnt)) return 0;
	ExecuteHamB(Ham_Item_Kill, wEnt);
	
	set_pev(id, pev_weapons, pev(id, pev_weapons) & ~(1<<wId));
	
	return 1;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
